﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using OpenTK;
//using OpenTK.Graphics;
using OpenTK.Graphics.OpenGL;
using OpenTK.Audio;
using OpenTK.Audio.OpenAL;
using OpenTK.Input;


namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        float AngleX = 0;
        float AngleY = 0;
        float AngleZ = 0;

        const float AngleDl = 5;

        public Form1()
        {
            InitializeComponent();
        }

        private void glControl1_Resize(object sender, EventArgs e)
        {
            SetupViewport();
            glControl1.Invalidate();
        }

        private void SetupViewport()
        {
            int w = glControl1.Width;
            int h = glControl1.Height;
            GL.MatrixMode(MatrixMode.Projection);
            GL.LoadIdentity();
            GL.Ortho(0, w, 0, h, -1, 1); 
            GL.Viewport(0, 0, w, h); 
        }
        private void glControl1_Paint(object sender, PaintEventArgs e)
        {

            GL.ClearColor(0.5f, 0.5f, 0.75f, 1.0f); // цвет фона
            // очистка буферов цвета и глубины
            GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);
            // поворот изображения
            GL.LoadIdentity();
            GL.Rotate(AngleX, 1.0, 0.0, 0.0);
            GL.Rotate(AngleY, 0.0, 1.0, 0.0);
            GL.Rotate(AngleZ, 0.0, 0.0, 1.0);

            // формирование изображения
            GL.Begin(BeginMode.Lines);
                GL.Vertex3(-0.5, -0.5, 0);
                GL.Vertex3(-0.5, 0.5, 0);
                GL.Vertex3(0, -0.5, 0);
                GL.Vertex3(0, 0.5, 0);
                GL.Vertex3(0.5, -0.5, 0);
                GL.Vertex3(0.5, 0.5, 0);
                GL.Vertex3(0.7, -0.5, 0);
            GL.End();
            // завершение формирования изображения

            GL.Flush();
            GL.Finish();

            glControl1.SwapBuffers();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            SetupViewport();
        }

        private void glControl1_KeyDown(object sender, KeyEventArgs e)
        {
            switch(e.KeyCode)
            {
                case Keys.Insert: 
                    AngleX += AngleDl;
                    break;
                case Keys.Delete: 
                    AngleX -= AngleDl;
                    break;
                case Keys.Home: 
                    AngleY += AngleDl;
                    break;
                case Keys.End: 
                    AngleY -= AngleDl;
                    break;
                case Keys.Prior: 
                    AngleZ += AngleDl;
                    break;
                case Keys.Next: 
                    AngleZ -= AngleDl;
                    break;
            }
            glControl1.Invalidate(); 
        }
    }
}
